unit Regmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, DBGrids, DBTables, Grids, Mask, ExtCtrls,
  DBLookup, Buttons, ProgEdit, IceLock, Menus, RegDial;

type
  TMainForm = class(TForm)
    DBNavigator: TDBNavigator;
    Panel1: TPanel;
    UserSource: TDataSource;
    UserTable: TTable;
    DetailTable: TTable;
    DetailSource: TDataSource;
    Panel2: TPanel;
    EditRegisteredName: TDBEdit;
    Label1: TLabel;
    EditName: TDBEdit;
    Label2: TLabel;
    EditAdd: TDBEdit;
    Label3: TLabel;
    EditAdd2: TDBEdit;
    EditCity: TDBEdit;
    EditState: TDBEdit;
    EditZip: TDBEdit;
    Label11: TLabel;
    EditEMail: TDBEdit;
    Label12: TLabel;
    EditPhone: TDBEdit;
    Label13: TLabel;
    EditFax: TDBEdit;
    RegProgGroup: TGroupBox;
    RegisteredGrid: TDBGrid;
    AvailProgs: TGroupBox;
    ProgTable: TTable;
    ProgSource: TDataSource;
    ProgList: TListBox;
    IceLock1: tIceLock;
    DetailTableRegisteredName: TStringField;
    DetailTableProgramName: TStringField;
    DetailTableKey: TStringField;
    DetailTablePrice: TCurrencyField;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    Register1: TMenuItem;
    EditProgButt: TBitBtn;
    procedure RegisteredGridDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure RegisteredGridDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure UpdateProgramList;
    procedure FormCreate(Sender: TObject);
    procedure EditProgButtClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Register1Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.RegisteredGridDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  key,Name,
  ProgName : String;
begin
  if Source = ProgList then
  begin
    ProgName := ProgList.Items[ProgList.ItemIndex];
    Name := EditRegisteredName.Text;
    if ProgTable.FindKey([ProgName]) then
    begin
      IceLock1.ProgramKey1 := ProgTable.Fields[5].AsInteger;
      IceLock1.ProgramKey2 := ProgTable.Fields[6].AsInteger;
      Key := IceLock1.BuildUserKey(Name);
      DetailTable.InsertRecord([
                             ProgTable.Fields[0],
                             Key,
                             ProgTable.Fields[7],
                             Name]);
    end;
  end;
end;

procedure TMainForm.RegisteredGridDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if Source = ProgList then Accept := true
    else Accept := false;
end;

procedure tMainForm.UpdateProgramList;
begin
  ProgList.Clear;
  ProgTable.First;
  while not ProgTable.Eof do
  begin
    ProgList.Items.Add(ProgTable.Fields[0].AsString);
    ProgTable.Next;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  UserTable.Open;
  ProgTable.Open;
  DetailTable.Open;
  UpdateProgramList;
  IceLock1.LoadKeyFile;
  Caption := 'Registered to: ' + IceLock1.GetName;
  if IceLock1.IsRegistered then EditProgButt.Enabled := true
    else EditProgButt.Enabled := false;
end;

procedure TMainForm.EditProgButtClick(Sender: TObject);
begin
  ProgEditForm.ShowModal;
  UpdateProgramList;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TMainForm.Register1Click(Sender: TObject);
begin
  if RegisterForm.ShowModal = idOk then
  begin
    if IceLock1.LoadKeyFile = ieOkay then
    begin
      Caption := 'Registered to: ' + IceLock1.GetName;
      EditProgButt.Enabled := true;
    end;
  end;
end;

end.
